Home | History | Annotate | Download | only in rbind
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test30} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST30***************"
     29 tst_resm TINFO "rbind: shared subtree with uncloneable child to private subtree."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of rbind/test30 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 
     44 	"${FS_BIND_ROOT}/bin/makedir" share parent1
     45 	"${FS_BIND_ROOT}/bin/makedir" priv parent2
     46 	"${FS_BIND_ROOT}/bin/makedir" share share1
     47 
     48 	mount --rbind share1 parent1
     49 
     50 	"${FS_BIND_ROOT}/bin/makedir" unclone parent1/child1
     51 	mount --rbind "$disk1" parent1/child1
     52 	mount --rbind parent1 parent2
     53 
     54 	check -n parent1/child1 share1/child1
     55 	check -n parent1/child1 parent2/child1
     56 
     57 	break
     58 done
     59 trap 'ERR=$? ; tst_resm TWARN "rbind/test30: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     60 if [ -n "${ERR_MSG}" ]; then
     61 	tst_resm TWARN "rbind/test30: ${ERR_MSG}"
     62 	ERR_MSG=""
     63 	result=$ERR
     64 fi
     65 trap '' ERR
     66 {
     67 	umount parent1/child1
     68 	umount parent1/child1
     69 	umount parent2
     70 	umount parent2
     71 	umount parent1
     72 	umount share1
     73 	umount parent1
     74 
     75 	rm -rf parent* share*
     76 	cleanup
     77 } >& /dev/null
     78 if [ $result -ne 0 ]
     79 then
     80 	tst_resm TFAIL "rbind/test30: FAILED: rbind: shared subtree with uncloneable child to private subtree."
     81 	exit 1
     82 else
     83 	tst_resm TPASS "rbind/test30: PASSED"
     84 	exit 0
     85 fi
     86 tst_exit
     87